import algorithms from './algorithms';
import { EncodingKey, JWTBody, JWTHeader, DecodingOptions, JWTToken } from '../types/jwt';
type AlgorithmFunction = (typeof algorithms)['HS256'];
declare class Decoder<T> {
    _header: JWTHeader;
    _body: JWTBody<T>;
    options: DecodingOptions;
    algorithm: 'none' | AlgorithmFunction;
    signature: string;
    constructor(key: EncodingKey);
    set header(header: string);
    set body(body: string);
    getAlgorithm(): any;
    verifySignature(encodedHeader: string, encodedBody: string): boolean;
    verifyClaims(): void;
    decodeAndVerify(token: JWTToken, options?: DecodingOptions): JWTBody<T>;
}
export default Decoder;
